#include <stdio.h>
#include "trf/trf_tarr.hpp"

typedef  enum { typeInt=0,
                typeChar,
                typeFloat,
                typeExpr,
                typeUninit
} TypeOfTerm;

#include "trf/trf_term.hpp"

class Expr{
public:
  ts::TPtr < TArr<Term> > chunk;

  Expr(){
    ts::TVar < TArr<Term> > my_chunk;
    
    chunk = &my_chunk;

    Term *ptr;

    Term aa(5);
    Term bb(7);

    ptr = chunk->alloc(2);
    ptr[0] = aa;
    ptr[1] = bb;
  }

  void print(){
    printf("Expr: ");
    Term *terms;
    terms = chunk->getData();

    for(uint i=0; i<chunk->extDataSize(); i++){
      printf("[%d]", ((Term&)terms[i]).getInt());
    }
    printf("\n");
  }

};

tfun int f (tval Expr arg) {
  printf("Rank%d: ", ts::myRank);

  Expr& arg2 = (Expr&)arg;

  arg2.print();

  //  ((Expr&)arg).print();

  return 0;
} 

tfun int main(int argc,char *argv[]) {
  int res;
  {
    tct(atRank(ts::realsuperSize > 1 ? 1 : 0));

    tval Expr exp1;
    tval Expr exp2;

    ((Expr&)exp1).print();
    ((Expr&)exp2).print();

    //    tval Expr exp = Expr(exp1, exp2); //Expr::concatenate(exp1, exp2);

    //    ((Expr&)exp).print();

    res = f(exp1); 

  }
  return res;
}
