#include <stdio.h>
#include "trf/trf_core.hpp"

tfun int f (tval Expr arg) {
  printf("Rank%d: ", ts::myRank);

  ((Expr&)arg).dump();

  tval Expr new_exp = Expr(arg, 1);
  ((Expr&)new_exp).dump();

  return 0;
} 

tfun int main(int argc,char *argv[]) {
  int res;
  {
    tct(atRank(ts::realsuperSize > 1 ? 1 : 0));

    tval Expr exp1(5);
    tval Expr exp2(4);

    ((Expr&)exp1).dump();
    ((Expr&)exp2).dump();

    tval Expr exp = Expr::concatenate(Expr::concatenate(exp1, exp2), Expr::concatenate(exp1, exp2));

    ((Expr&)exp).dump();

    tval Expr mega_exp = Expr::parentheses(&exp);
    ((Expr&)mega_exp).dump();

    res = f(exp); 
  }
  return res;
}
