class Term { 

public:
  TypeOfTerm type; 
  
  Term():type(typeUninit) {};

  Term(Term& rhs) {
    (*this)=rhs;
  }


  inline Term(const int i) : subexpr(NULL) {setInt(i);}

  inline Term(const char c) {setChar(c);} 
  inline Term(const float f) {setFloat(f);}
  inline Term(ts::TPtr<Expr> expr) {setExpr(expr);}

  inline void setInt(const int i) { ival=i; type=typeInt; }

  inline void setChar(const char c) { cval=c; type=typeChar; }
  inline void setFloat(const float f) { fval=f; type=typeFloat; }
  inline void setExpr(ts::TPtr<Expr> expr) { subexpr=expr; type=typeExpr; }


  inline int getInt () { 
    assert (type==typeInt);
    return ival; 
  }


  inline char getChar () {
    assert(type==typeChar);
    return cval; 
  }
  
  inline float getFloat() {
    assert(type==typeFloat);
    return fval;
  }

  ts::TPtr<Expr> getExpr() {
    assert(type==typeExpr);
    return subexpr;
  }

  Term& operator=(const Term& rhs) {
    type= rhs.type;
    ival = rhs.ival;
    cval=rhs.cval;
    fval=rhs.fval;

    if ( type == typeExpr ) subexpr=rhs.subexpr;
    //else subexpr=NULL;
    return *this;
  }


protected:
  
  int ival;
  char cval;
  float fval; 
  
  ts::TPtr<Expr> subexpr;
  
};
