#include <stdio.h>
#include "trf/trf_core.hpp"

class Arithm{
public:
  static Expr _p_(Expr exp1, Expr exp2){
    int res = exp1.elementAt(0).getInt() +  exp2.elementAt(0).getInt();
    Expr exp_res(res);
    return exp_res;
  }
};

tfun int fib(int n, tout Expr res){
  if (n <= 1){
    tval Expr res_exp(n);
    res = (Expr&)res_exp;
  }
  else{
    tval Expr res1, res2;
    fib(n-1, res1);
    fib(n-2, res2);
    tval Expr res_exp;
    res_exp = Arithm::_p_(res1, res2);
    res = (Expr&)res_exp;
  }
  return 0;
}

tfun int make(int n, tout Expr res){
  tval Expr exp(n);
  if (n == 1){
    tval Expr res_exp(1);
    res = (Expr&)res_exp;
  }
  else{

    tval Expr res_exp;
    tval Expr exp_n(n);
    tval Expr local, res_local;

    fib(n, res_local);

    tval Expr tmp;

    //    local = Expr::concatenate((Expr&)exp_n, Expr::parentheses(&res_local));
    local = Expr::concatenate((Expr&)exp_n, res_local);

    make(n-1, res_exp);

    tval Expr sum;

    sum = Expr::concatenate((Expr&)local, (Expr&)res_exp);

    res = (Expr&)sum;
  }
  return 0;
}

tfun int main(int argc, char *argv[]){
  tval Expr res;

  make(21, res);

  ((Expr&)res).dump();

  return 0;
}
